#ifndef APPLICATION_H
#define APPLICATION_H

#include "disparitycheckerinterface.h"
#include "logger.h"
#include "settings.h"

#define THREAD_WAIT 250

using namespace cv;

class Application
{
private:
    struct Rects{
        Rect left;
        Rect right;
    };
    Application::Rects* getOrientationRects(string orientation, int width, int height);

    int executeNative(string input[], string orientation, DisparityCheckerInterface* disparityChecker, unsigned int threads, string output, string sequence);
    int executeMovie(string input[], string orientation, DisparityCheckerInterface* disparityChecker, unsigned int threads, string output, string sequence);
    int executeImage(string input[], string orientation, DisparityCheckerInterface* disparityChecker, string output);

public:
    int execute(string input[], string orientation, string sequence, string disparity, string parameters, string threads, string output);
    virtual void update(Mat left, Mat right, int id, int size, vector<Result*> results, Mat summary, string name)=0;
};
#endif // APPLICATION_H
