#ifndef CORRELATION_H
#define CORRELATION_H

#include "disparitycheckerinterface.h"

#include <opencv2/features2d/features2d.hpp>

class DisparityCheckerInterface;

using namespace cv;
using namespace std;

class Correlation
{
private:
    vector<KeyPoint> keypointsLeft;
    vector<KeyPoint> keypointsRight;
    vector<DMatch> matches;

public:
    static Correlation* execute(DisparityCheckerInterface* disparityChecker, Mat left, Mat right);

    Correlation(vector<KeyPoint> keypointsLeft, vector<KeyPoint> keypointsRight, vector<DMatch> matches);
    vector<KeyPoint> getKeypointsLeft();
    vector<KeyPoint> getKeypointsRight();
    vector<DMatch> getMatches();
};

#endif // CORRELATION_H
