#ifndef QUALITYMEASURE_H
#define QUALITYMEASURE_H

#include "correlation.h"
#include "result.h"

#include <time.h>

class Correlation;

class DisparityCheckerInterface
{
public:
    static DisparityCheckerInterface* getInstance(string qualityMeasure, string parameters);

protected:
    string parameters;

public:
    string getParameter(string name);
    virtual Mat correct(Mat image, double value)=0;
    virtual vector<Result*> execute(Correlation* correlation, Mat left, Mat right)=0;
    virtual Mat summary(vector<Result*> results)=0;
};

#endif // QUALITYMEASURE_H
