#include "guiapplication.h"
#include "utils.h"

#include <iostream>
#include <opencv2/opencv.hpp>

#define THREAD_WAIT 4000

#define MAX_WIDTH 960
#define MAX_HEIGHT 540

GUIApplication::GUIApplication(){
}

void GUIApplication::update(Mat left, Mat right, int id, int size, vector<Result*> results, Mat summary, string name){
    for(Result* result: results) {
        cout << name << " : " << id << " / " << size << " " << result->getName() << endl;
        for(Result::KeyValue* data: result->getData()){
            cout << data->getKey() << " : " << data->getValue() << endl;
        }
        cout << "-------------------------------------------------------------" << endl;
    }
    cout << "-------------------------------------------------------------" << endl;

    startWindowThread();
    namedWindow("Disparity Checker", WINDOW_AUTOSIZE);
    moveWindow("Disparity Checker", 0, 0);

    Mat window;
    double scale = std::min((double)MAX_WIDTH/summary.cols, (double)MAX_HEIGHT/summary.rows);
    resize(summary, window, Size(scale * summary.cols, scale * summary.rows));

    imshow("Disparity Checker", window);
    waitKey(THREAD_WAIT);
    window.release();
}
