#include "result.h"

Result::Result(string name, vector<Result::KeyValue*> data, vector<Result::KeyImage*> images){
    this->name = name;
    this->data = data;
    this->images = images;
}

Result::~Result(){
    for(Result::KeyValue* value: this->getData()){
        delete value;
    }
    for(Result::KeyImage* image: this->getImages()){
        image->getImage().release();
        delete image;
    }
}

string Result::getName(){
    return this->name;
}

vector<Result::KeyValue*> Result::getData(){
    return this->data;
}

vector<Result::KeyImage*> Result::getImages(){
    return this->images;
}
