#ifndef RESULT_H
#define RESULT_H

#include <opencv2/highgui/highgui.hpp>
#include <string>

using namespace cv;
using namespace std;

class Result
{
public:
    class KeyValue
    {
    private:
        string key;
        double value;

    public:
        KeyValue(string key, double value){
            this->key = key;
            this->value = value;
        }

        string getKey(){
            return this->key;
        }

        double getValue(){
            return this->value;
        }
    };

public:
    class KeyImage
    {
    private:
        string key;
        Mat image;

    public:
        KeyImage(string key, Mat image){
            this->key = key;
            this->image = image;
        }

        string getKey(){
            return this->key;
        }

        Mat getImage(){
            return this->image;
        }
    };

private:
    string name;
    vector<KeyValue*> data;
    vector<KeyImage*> images;

public:
    Result(string name, vector<KeyValue*> data, vector<KeyImage*> images);
    ~Result();

    string getName();
    vector<KeyValue*> getData();
    vector<KeyImage*> getImages();
};
#endif // RESULT_H
